<?php
/************************************************************
Program		Slashorg Downloader
Filename	admin.php
Version		0.99
Last update	09/05/2006

Send bug reports to dev@slashorg.net
************************************************************/

if (!file_exists('conf.php')) {
	Header ('Location: setup/');
	exit();
}

// We disable 'register_globals' for security reasons
ini_set('register_globals', 'off');

$start_time = microtime();
include ('conf.php');
include ('include/inc_functions.php');

require_once ('include/inc_mysql.php');

if (in_array('iconv', get_loaded_extensions())) {
	iconv_set_encoding('output_encoding', $conf_charset);
	ob_start('ob_iconv_handler');
}

// Stripslashes from magic quote-enabled servers.
if (get_magic_quotes_gpc()) {
	foreach ($_POST as $key => $value) {
		$_POST[$key] = stripslashes ($value);
	}
}

session_start();

$act = $item = $warning = $redirect = NULL;

if (isset($_GET['item']))
	$item = addslashes($_GET['item']);
if (isset($_GET['act']))
	$act = $_GET['act'];

// Language support
// The 'preg_match' is a security feature.
if (isset($_SESSION['user_lang']) && !preg_match('/\.\./', $_SESSION['user_lang'])) {
	require_once ("lang/{$_SESSION['user_lang']}.php");
} else {
	$_SESSION['user_lang'] = $SetDisplayLang;
	require_once ("lang/$SetDisplayLang.php");
}

// MySQL database connection
$db = new MySQL($db_access['host'], $db_access['database'], $db_access['username'], $db_access['password']);

// Check for admin privileges
$html = $lang['access_denied'];

if (isset($_SESSION['session_key'])) {
	$hash_key = $_SESSION['session_key'];
	$q0 = $db->query('SELECT dir, is_admin FROM cgd_access WHERE hash = \'' . addslashes($hash_key) . '\'');
	if ($db->num_rows($q0) == 1) {
		$var = $db->assoc($q0);
		if ($var['is_admin'] == 1 && !$var['dir'])
			$html = NULL;
	}
}

if ($html) { // User is not admin
	include('include/inc_header.php');
	$nav = '<p>'.$lang['location'].' <a href="./">Home</a> > <a href="admin.php">'.$lang['control_panel'].'</a></p><br />'."\n";
	echo ($nav);
	include('include/inc_text_zone.php');
	include('include/inc_footer.php');
	exit();
}

switch ($act) {
case 'users':
	$title = $lang['user_mgmt'];
	// We close the <p> marker later in the script
	$nav = "<p>\n";
	$nav .= $lang['location'].' <a href="./">Home</a> > <a href="admin.php">'.$lang['control_panel'].'</a> > <a href="admin.php?act=users">'.$lang['user_mgmt'].'</a>';
	if ($item) {
		$q0 = $db->query("SELECT name, passwd, email, dir, is_admin FROM cgd_users WHERE id = '$item'");
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);
			$name = $var['name'];
			$email = $var['email'];
			$path = $var['dir'];
			$is_admin = $var['is_admin'];

			$nav .= ' > '.$name."</p><br />\n";

			if($_POST) {
				if (isset($_POST['delete'])) {
					// Delete user from user table
					$q0 = $db->query("DELETE FROM cgd_users WHERE id = '$item'");

					// Delete user session
					$q0 = $db->query("DELETE FROM cgd_access WHERE user_account= '".addslashes($name)."'");
					$html = '<p>'.$lang['user_removed'].'<br /><br />[<a href="admin.php?act=users">'.$lang['goto_users']."</a>]</p>\n";
				} else {
					if (isset($_POST['del_ses'])) {
						// Delete user session
						$q0 = $db->query("DELETE FROM cgd_access WHERE user_account= '".addslashes($name)."'");
					}

					if($_POST['path'] && substr($_POST['path'], -1, 1) != '/') {
                                                $_POST['path'] = $_POST['path'].'/';
                                        }

					if (($email = $_POST['email']) != $var['email'])
						$html = "{$lang['email_updated']}<br />";

					if (($dir = $_POST['path']) != $var['dir'])
						$html .= "{$lang['path_updated']}<br />";

					if ($_POST['pw']) {
						$pw = md5($_POST['pw']);
						$html .= "{$lang['pw_updated']}<br />";
					} else {
						$pw = $var['passwd'];
					}

					// 0 = normal
					// 1 = admin
					// 2 = uploader
					// 4 = deleter
					// Example: 6 = uploader AND deleter

					$is_admin = 0;
					if (isset($_POST['is_admin'])) {
						$is_admin = 1;
					} else {
						if (isset($_POST['is_uploader']))
							$is_admin += 2;
						
						if (isset($_POST['is_deleter']))
							$is_admin += 4;
					}

					if ($is_admin != $var['is_admin'])
						$html .= "{$lang['status_updated']}<br />";

					if (!$html)
						$html = "{$lang['no_changes']}<br />";

					$html = '<p>' . $html . '<br />[<a href="admin.php?act=users">'.$lang['goto_users'].'</a>]</p>';

					$q0 = $db->query("UPDATE cgd_users SET passwd = '$pw', email = '" . addslashes($email) . "', dir = '" . addslashes($dir) . "', is_admin = '$is_admin' WHERE id = '$item'");
				}
				
				break;
			}

			include('include/inc_header.php');
			echo ($nav);
			include('include/inc_admin_user_form.php');
			include('include/inc_footer.php');
			exit();
		} else {
			$nav .= "</p><br />\n";
			$html = '<p>User not found.</p>';
		}
	} else {
		$nav .= "</p><br />\n";
		$html = "<p>{$lang['select_user_admin']}</p>\n";
		$html .= "<ul>\n";
		$q0 = $db->query('SELECT id, name, is_admin FROM cgd_users');
		while ($var = $db->assoc($q0)) {
			$html .= '<li><p><a href="admin.php?act=users&amp;item=' . $var['id'] . '">' . $var['name'] . '</a> ['.$lang['account_type'];


			switch ($var['is_admin']) {
			case 1:
				$html .= ' admin';
				break;
			case 2:
				$html .= ' write';
				break;
			case 4:
				$html .= ' delete';
				break;
			case 6:
				$html .= ' write+delete';
				break;
			default:
				$html .= ' normal';
				break;
			}

			$html .= ']</p></li>' . "\n";
		}

		$html .= "</ul>\n";
	}
	break;

case 'shares':
	$title = $lang['edit_shares'];
	$nav = "<p>\n";
        $nav .= $lang['location'].' <a href="./">Home</a> > <a href="admin.php">'.$lang['control_panel'].'</a> > <a href="admin.php?act=shares">'.$lang['edit_shares'].'</a>';

	if ($item) {
		$q0 = $db->query("SELECT end_date, uses_left, dir, ip, is_admin, can_create_account FROM cgd_access WHERE id = '$item'");
		if ($db->num_rows($q0) == 1) {
			$var = $db->assoc($q0);

			if ($var['dir'])
				$nav .= " > {$var['dir']}</p><br />\n";
			else
				$nav .= " > /</p><br />\n";

			if($_POST) {
				if (isset($_POST['delete'])) {
					$q0 = $db->query("DELETE FROM cgd_access WHERE id = '$item'");
					$html = '<p>'.$lang['share_removed'].'<br /><br />[<a href="admin.php?act=shares">'.$lang['goto_shared']."</a>]</p>\n";
				} else {
					$html = "{$lang['expire_date_updated']}<br />";

					if ($_POST['access_limit'] != $var['uses_left'])
						$html .= "{$lang['access_limit_changed']}<br />";

					if (isset($_POST['ip_limit']))
						$ip_limit = NULL;
					else
						$ip_limit = '0.0.0.0';

					if (($var['ip'] != '0.0.0.0' && $ip_limit == '0.0.0.0') ||  ($var['ip'] == '0.0.0.0' && !$ip_limit))
						$html .= "{$lang['ip_strat_changed']}<br />";

					
					if (isset($_POST['is_admin'])) {
						$is_admin = 1;
					} else {
						$is_admin = 2 * isset($_POST['is_uploader']) + 4 * isset($_POST['is_deleter']);
					}

					if ($is_admin != $var['is_admin'])
						$html .= "{$lang['adm_strat_changed']}<br />";

					if (isset($_POST['new_account']))
						$new_account = 1;
					else
						$new_account = 0;

					if ($new_account != $var['can_create_account'])
						$html .= "{$lang['account_strat_changed']}<br />";

					if ($_POST['days'] == -1)
						$end_date = 0;
					else
						$end_date = 60 * $_POST['mins'] + 3600 * $_POST['hours'] + 86400 * $_POST['days'] + time();

					if (!$html)
						$html = "{$lang['no_changes']}<br />";

					$html = '<p>' . $html . '<br />[<a href="admin.php?act=shares">'.$lang['goto_shared'].'</a>]</p>';

					$q0 = $db->query("UPDATE cgd_access SET end_date = '$end_date', uses_left = '" . $_POST['access_limit'] . "', ip = '$ip_limit', is_admin = '$is_admin', can_create_account = '$new_account' WHERE id = '$item'");
				}
				
				break;
			}

			$allow_delete = true;
			$ip_checked = $admin_checked = $uploader_checked = $deleter_checked = $new_checked = '';
			$action = 'admin.php?act=shares&amp;item=' . $item;

			if ($var['end_date'] == 0) {
				$days = -1;
				$hours = $mins = 0;
			} else {
				$expire = $var['end_date'] - time();
				$expire -= ($days = floor($expire/60/60/24))*60*60*24;
				$expire -= ($hours = floor($expire/60/60))*60*60;
				if (($mins = floor($expire/60)) < 0 || $hours < 0 || $days < 0)
					$days = $hours = $mins = 0;
			}

			$access_limit = $var['uses_left'];

			if ($var['ip'] != '0.0.0.0')
				$ip_checked = 'checked="checked" ';

			switch ($var['is_admin']) {

			case 1:
				$admin_checked = 'checked="checked"';
				$uploader_checked = $deleter_checked = 'checked="checked" disabled="disabled"';
				break;

			case 2:
				$uploader_checked = 'checked="checked"';
				break;

			case 4:
				$deleter_checked = 'checked="checked"';
				break;

			case 6:
				$uploader_checked = 'checked="checked"';
				$deleter_checked = 'checked="checked"';
				break;

			default:
				break;
			}

			if ($var['can_create_account'])
				$new_checked = 'checked="checked" ';

			include('include/inc_header.php');
			include('include/inc_javascript_popup.php');
			echo ($nav);
			include('include/inc_new_share_form.php');
			include('include/inc_footer.php');
			exit();
		} else {
			$html = "<p>{$lang['share_not_found']}</p>";
			$nav .= "</p><br />\n";
		}
	} else {
		$html = "<p>{$lang['select_folder_admin']}</p>\n";
		$nav .= "</p><br />\n";

		$q0 = $db->query('SELECT id, end_date, hash, dir FROM cgd_access WHERE user_account is null');

		if ($db->num_rows($q0)) {
			$html .= "<ul>\n";

			while ($var = $db->assoc($q0)) {
				$html .= '<li><p><a href="admin.php?act=shares&amp;item=' . $var['id'] . '">';
				if ($var['dir'])
					$html .= $var['dir'];
				else
					$html .= '[total access]';

				$html .= '</a> <a href="./?key=' . $var['hash'] . '">[key]</a> ['.$lang['expires_in'].' ';
				$expire = $var['end_date'] - time();
				if ($expire <= 0) {
					if ($var['end_date'] == 0)
						$html .= $lang['never'];
					else
						$html .= $lang['share_expired'];
				} else {
					if (($days = floor($expire/60/60/24)) != 0)
						$html .= "$days ".strtolower($lang['days']);
					$expire -= $days*60*60*24;
					if (($hours = floor($expire/60/60)) != 0) {
						if ($days)
							$html .= ', ';
						$html .= "$hours ".strtolower($lang['hours']);
					}
					$expire -= $hours*60*60;
					if (($minutes = floor($expire/60)) != 0) {
						if ($hours || $days)
							$html .= ' '.$lang['and'];
						$html .= " $minutes ".strtolower($lang['minutes']);
					}

					if (!$days && !$hours && !$minutes)
						$html .= $lang['less_than_min'];
				}
				$html .= ']</p></li>' . "\n";
			}

			$html .= "</ul>\n";
		} else {
			$html = '<p>'.$lang['no_shared'].'<br /><br >[<a href="admin.php">'.$lang['goto_admin'].'</a>]</p>';
		}
	}
	break;

case 'new_account':
	$warning = $lang['admin_new_account'];
	$name = $email = NULL;
	$action = 'admin.php?act=new_account';
	$nav = '<p>'.$lang['location'].' <a href="./">Home</a> > <a href="admin.php">'.$lang['control_panel'].'</a> > <a href="admin.php?act=new_account">'.$lang['new_account']."</a></p><br />\n";
	if($_POST) {
		$name = $_POST['name'];
		$email = $_POST['email'];
		$pw1 = $_POST['pw1'];
		$pw2 = $_POST['pw2'];
		if ($name && $email && $pw1 && $pw2) {
			if ($pw1 == $pw2) {
				$q0 = $db->query("SELECT id FROM cgd_users WHERE name = '" . addslashes($name) . "'");
				if (!$db->num_rows($q0)) {
					$pw1 = md5($pw1);
					$q0 = $db->query("INSERT INTO cgd_users VALUES ('', '" . addslashes($name) . "', '$pw1', '" . addslashes($email) . "', '', '0')");
					$warning = NULL;
					$title = $lang['new_account'];
					$html = '<p>'.$lang['account_creation_successful'].'<br /><br />[<a href="admin.php">'.$lang['continue'].'</a>]</p>';
					break;
				} else { // Account already exists.
					$warning = $lang['duplicated_account'];
				}
			} else {
				$warning = $lang['different_pw'];
			}
		} else {
			$warning = $lang['empty_fields'];
		}
	}


	include('include/inc_header.php');
	echo ($nav);
	include('include/inc_new_account_form.php');
	include('include/inc_footer.php');
	exit();
	break;

default:
	$title = $lang['control_panel'];
	$nav = '<p>'.$lang['location'].' '.display_nav($p, $UploadDir).' > <a href="admin.php">'.$lang['control_panel']."</a></p><br />\n";
	$html = "<p>\n";
	$html .= "{$lang['resource_select']}<br />\n";
	$html .= "<ul>\n";
	$html .= '<li><a href="admin.php?act=users">'.$lang['user_mgmt']."</a></li>\n";
	$html .= '<li><a href="admin.php?act=shares">'.$lang['edit_shares']."</a></li>\n";
	$html .= '<li><a href="admin.php?act=new_account">'.$lang['new_account']."</a></li>\n";
	$html .= "</ul>\n";
	$html .= "</p>\n";
	break;
}

include('include/inc_header.php');
echo ($nav);
include('include/inc_admin_zone.php');
include('include/inc_footer.php');
?>
